<template>
  <CModal
    :show.sync="visible"
    :centered="false"
    :close-on-backdrop="false"
    size="lg"
    class="item-modal"
    @open="$emit('open')"
    @close="$emit('close')"
  >
    <div
      v-loading="loading"
      class="box-inner-form"
    >
      <div class="row">
        <div class="col-12 col-xl-6">
          <CCarousel
            v-if="model.images.length"
            ref="slider"
            arrows
            indicators
            animate
            height="450px"
            :interval="5000"
          >
            <CCarouselItem
              v-for="item in model.images"
              :key="item.id"
              :image="item.path"
            />
          </CCarousel>

          <div v-if="model.images.length" class="thumbnail">
            <img v-for="(item, index) in model.images" :key="item.id" width="50" :src="item.path" @click="$refs.slider.setItem(index)">
          </div>

          <table class="table table-hover">
            <thead>
              <th colspan="3">
                落札
              </th>
            </thead>

            <tbody>
              <tr>
                <td>箱番 / 行</td>
                <td>{{ model.box.name }}</td>
                <td>{{ model.number }}</td>
              </tr>

              <tr>
                <td>品名</td>
                <td colspan="2">
                  {{ model.name }}
                </td>
              </tr>

              <tr>
                <td>備考</td>
                <td colspan="2">
                  {{ model.note }}
                </td>
              </tr>
            </tbody>
          </table>
        </div>

        <div class="col-12 col-xl-6">
          <div class="row">
            <div class="col-xl-6">
              <h4>
                落札者
              </h4>
            </div>
            <div class="col-xl-6">
              <h4>
                {{ currency(model.current_price) }}
              </h4>
            </div>
          </div>

          <div class="row">
            <div class="col-xl-6">
              <h4>
                入札額
              </h4>
            </div>
            <div class="col-xl-6">
              <h4>
                {{ currency(model.starting_price) }}
              </h4>
            </div>
          </div>

          <div class="row">
            <div class="col-xl-6">
              <h4>
                入札数
              </h4>
            </div>
            <div class="col-xl-6">
              <h4>
                {{ model.number }}
              </h4>
            </div>
          </div>

          <div class="row">
            <div class="col-xl-6">
              <h4>
                自入札額
              </h4>
            </div>
            <div class="col-xl-6">
              <h4>
                {{ ownBid(model.bids) }}
              </h4>
            </div>
          </div>
        </div>
      </div>
    </div>

    <template #footer>
      <div class="row">
        <div class="col-3" />
        <div class="col-6 text-center">
          <CButton :disabled="!model.prev_id || loading" @click="gotoPrevItem()">
            <font-awesome-icon :icon="['fas', 'arrow-left']" class="width-1x" />
            前へ
          </CButton>

          <CButton :disabled="!model.next_id || loading" @click="gotoNextItem()">
            次へ
            <font-awesome-icon :icon="['fas', 'arrow-right']" class="width-1x" />
          </CButton>
        </div>
        <div class="col-3 text-right">
          <CButton
            variant="outline"
            color="dark"
            @click="visible = false"
          >
            クリア
          </CButton>
        </div>
      </div>
    </template>
  </CModal>
</template>

<style lang="scss" scoped>
  .item-modal {
    /deep/ {
      .modal-footer {
        display: block;
      }
    }
  }
</style>

<script>
import { get } from 'lodash'
import common from '~/mixins/common'
import Item from '~/models/Item'

export default {
  mixins: [common],
  props: {
    /**
     * Item id
     */
    id: {
      type: Number,
      default: 0
    },
    idList: {
      type: Array,
      default: () => []
    }
  },

  data () {
    return {
      loading: false,
      currentPrice: 0,
      currentId: 0,
      memo: '',
      model: new Item(),
      visible: false
    }
  },

  computed: {
    /**
     * Deadline
     */
    endDate () {
      const deadline = get(this, 'model.box.deadline', null)
      return deadline ? this.$moment(deadline).format('DD/MM/YYYY HH:mm:ss') : ''
    }
  },

  watch: {
    // Parent ID
    id (val) {
      this.currentId = val
      this.getItemDetail()
    }
  },

  methods: {
    /**
     * Open dialog
     */
    open () {
      this.visible = true
    },

    /**
     * Get detail item
     */
    getItemDetail () {
      this.loading = true
      this.$dam.getItemDetail({ id: this.currentId })
        .then((res) => {
          this.model = new Item(res.data)
          this.currentPrice = this.model.current_price
          this.memo = get(this, 'model.memos[0].content', '')
          this.loading = false
        })
        .catch((err) => {
          this.showError(err)
          this.loading = false
        })
    },

    /**
     * Set memo for item
     */
    async setMemo () {
      this.loading = true
      try {
        await this.$dam.setMemo({ product_id: this.currentId, content: this.memo })

        this.$toast.success(
          this.$text.info('UPDATED')
        )
      } catch (err) {
        this.showError(err)
      }
      this.loading = false
    },

    /**
     * Bid an item
     */
    async bidItem () {
      this.loading = true
      try {
        await this.$dam.setBid({ product_id: this.currentId, price: this.currentPrice })

        this.$toast.success(
          this.$text.info('UPDATED')
        )
      } catch (err) {
        this.showError(err)
      }
      this.loading = false
    },

    /**
     * Currency converter
     *
     * @param {Number} money - Money number format
     */
    currency (money) {
      return new Intl.NumberFormat('ja-JP', { style: 'currency', currency: 'JPY' }).format(money)
    },

    /**
     * Currency converter
     *
     * @param {Array} bid - Owned bid
     */
    ownBid (bid) {
      if (bid && bid.length) {
        let total = 0
        bid.forEach((item) => {
          total += item.price
        })
        return total
      } else {
        const noneBid = 0
        return this.currency(noneBid)
      }
    },

    /**
     * Go to prev item
     */
    gotoPrevItem () {
      if (this.model.prev_id) {
        this.currentId = this.model.prev_id
        this.getItemDetail()
      }
    },

    /**
     * Go to next item
     */
    gotoNextItem () {
      if (this.model.next_id) {
        this.currentId = this.model.next_id
        this.getItemDetail()
      }
    }
  }
}
</script>
